# 定义各个部件的接口
class CPU:
    def describe(self):
        pass

class Disk:
    def describe(self):
        pass

class Memory:
    def describe(self):
        pass

class Motherboard:
    def describe(self):
        pass

class GPU:
    def describe(self):
        pass

class Monitor:
    def describe(self):
        pass

class PowerSupply:
    def describe(self):
        pass

class Case:
    def describe(self):
        pass


# 实现具体的部件类
# CPU
class IntelCPU(CPU):
    def __init__(self, model, frequency):
        self.model = model
        self.frequency = frequency

    def describe(self):
        return f"Intel CPU, 型号: {self.model}, 主频: {self.frequency} GHz"

class AMDCPU(CPU):
    def __init__(self, model, frequency):
        self.model = model
        self.frequency = frequency

    def describe(self):
        return f"AMD CPU, 型号: {self.model}, 主频: {self.frequency} GHz"

# 硬盘
class SSD(Disk):
    def __init__(self, capacity):
        self.capacity = capacity

    def describe(self):
        return f"固态硬盘, 容量: {self.capacity} GB"

class HDD(Disk):
    def __init__(self, capacity):
        self.capacity = capacity

    def describe(self):
        return f"机械硬盘, 容量: {self.capacity} GB"

# 内存
class DDR4Memory(Memory):
    def __init__(self, size):
        self.size = size

    def describe(self):
        return f"DDR4内存, 容量: {self.size} GB"

# 主板
class ASUSMotherboard(Motherboard):
    def __init__(self, model):
        self.model = model

    def describe(self):
        return f"华硕主板, 型号: {self.model}"

class GIGABYTEMotherboard(Motherboard):
    def __init__(self, model):
        self.model = model

    def describe(self):
        return f"技嘉主板, 型号: {self.model}"

# 显卡
class NVIDIAGPU(GPU):
    def __init__(self, model):
        self.model = model

    def describe(self):
        return f"NVIDIA显卡, 型号: {self.model}"

class AMDGPU(GPU):
    def __init__(self, model):
        self.model = model

    def describe(self):
        return f"AMD显卡, 型号: {self.model}"

# 显示器
class DellMonitor(Monitor):
    def __init__(self, size, resolution):
        self.size = size
        self.resolution = resolution

    def describe(self):
        return f"Dell显示器, 尺寸: {self.size}寸, 分辨率: {self.resolution}"

class ASUSMonitor(Monitor):
    def __init__(self, size, resolution):
        self.size = size
        self.resolution = resolution

    def describe(self):
        return f"华硕显示器, 尺寸: {self.size}寸, 分辨率: {self.resolution}"

# 电源
class CorsairPowerSupply(PowerSupply):
    def __init__(self, wattage):
        self.wattage = wattage

    def describe(self):
        return f"海盗船电源, 功率: {self.wattage}W"

class CoolerMasterPowerSupply(PowerSupply):
    def __init__(self, wattage):
        self.wattage = wattage

    def describe(self):
        return f"酷冷至尊电源, 功率: {self.wattage}W"

# 机箱
class CoolerMasterCase(Case):
    def __init__(self, model):
        self.model = model

    def describe(self):
        return f"酷冷至尊机箱, 型号: {self.model}"

class AntecCase(Case):
    def __init__(self, model):
        self.model = model

    def describe(self):
        return f"安钛克机箱, 型号: {self.model}"


# 定义计算机类
class Computer:
    def __init__(self, cpu, motherboard, gpu, memory, disk, monitor, power_supply, case):
        self.cpu = cpu
        self.motherboard = motherboard
        self.gpu = gpu
        self.memory = memory
        self.disk = disk
        self.monitor = monitor
        self.power_supply = power_supply
        self.case = case

    def assemble(self):
        print("开始组装计算机...")
        print(f"CPU: {self.cpu.describe()}")
        print(f"主板: {self.motherboard.describe()}")
        print(f"显卡: {self.gpu.describe()}")
        print(f"内存: {self.memory.describe()}")
        print(f"硬盘: {self.disk.describe()}")
        print(f"显示器: {self.monitor.describe()}")
        print(f"电源: {self.power_supply.describe()}")
        print(f"机箱: {self.case.describe()}")
        print("组装完成！")


# 创建实例并测试
if __name__ == "__main__":
    # 创建CPU实例
    cpu = IntelCPU(model="i7-13700K", frequency=5.2)
    # 创建主板实例
    motherboard = ASUSMotherboard(model="ROG Maximus Z690 Hero")
    # 创建显卡实例
    gpu = NVIDIAGPU(model="RTX 4090")
    # 创建内存实例
    memory = DDR4Memory(size=32)
    # 创建硬盘实例
    disk = SSD(capacity=1024)
    # 创建显示器实例
    monitor = DellMonitor(size=27, resolution="4K")
    # 创建电源实例
    power_supply = CorsairPowerSupply(wattage=1000)
    # 创建机箱实例
    case = CoolerMasterCase(model="MasterBox TD500 Mesh")

    # 组装计算机
    my_computer = Computer(cpu, motherboard, gpu, memory, disk, monitor, power_supply, case)
    my_computer.assemble()